searchData={"items":[{"type":"module","title":"TermStream","doc":"A Library for streaming Erlang terms into and out of binary streams. This is especially useful when storing large numbers of Erlang terms to file for later retrieval. When dealing with large files containing lots of Erlang terms, having to load the entire list into memory can be problematice. Using `TermStream` allows you to stream the terms one at a time out of the file.","ref":"TermStream.html"},{"type":"module","title":"Example - TermStream","doc":"```elixir\n# To write a stream of terms to a file:\n\nfile = File.stream!(\"my_file\", [:write, :binary])\n\nother_stream\n|> TermStream.serialize()\n|> Stream.into(file)\n|> Stream.run()\n\nFile.close(file)\n\n# The get a stream out of the same file later:\n\nFile.stream!(\"my_file\", 1024, [:read, :binary])\n|> TermStream.deserialize()\n|> Stream.run()\n\n```","ref":"TermStream.html#module-example"},{"type":"function","title":"TermStream.deserialize/1","doc":"Takes a stream of binary data representing erlang terms (as written by `TermStream.serialize/1` and returns a stream of the original terms.","ref":"TermStream.html#deserialize/1"},{"type":"function","title":"TermStream.serialize/2","doc":"Takes a stream of erlang terms and returns a stream of binary data representing those terms that is suitable for writing to a file without newlines or other delimiters.\n\nThis function takes an optional `opts` argument that is passed to `:erlang.term_to_binary/2`. This can be used to control the compression or other parameters of the serialization. See the documentation for `:erlang.term_to_binary/2` for more information.","ref":"TermStream.html#serialize/2"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}